#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityTimeShopCFG.h"
std::auto_ptr<M_ActivityTimeShopCFG> M_ActivityTimeShopCFG::msSingleton(nullptr);

int M_ActivityTimeShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTimeShopCFGData* M_ActivityTimeShopCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityTimeShopCFGData>& M_ActivityTimeShopCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityTimeShopCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityTimeShopCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTimeShopCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ItemIDs = element->Attribute("ItemIDs");
			std::vector<std::string> vecItemIDs;
			boost::split(vecItemIDs, ItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemIDs[i].c_str(), &temp))
				{
					data.mItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* ItemCounts = element->Attribute("ItemCounts");
			std::vector<std::string> vecItemCounts;
			boost::split(vecItemCounts, ItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCounts[i].c_str(), &temp))
				{
					data.mItemCounts.push_back(temp);
				}
			}
		}
		data.mweight = element->IntAttribute("weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityTimeShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTimeShopCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityTimeShopCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityTimeShopCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityTimeShopCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "ItemIDs", data.mItemIDs);
		LuaCfgHelper::readVectorInt(L, "ItemCounts", data.mItemCounts);
		LuaCfgHelper::readInt(L, "weight", data.mweight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityTimeShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTimeShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityTimeShopCFG* M_ActivityTimeShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTimeShopCFG());
	}
	return msSingleton.get();
}

void M_ActivityTimeShopCFG::Release()
{
	msSingleton.reset(nullptr);
}
